#! @BASH@
#
echo 1..12 # Number of tests to be executed.
#
. ./cdoTestFunctions.test
#
test -n "$CDO"      || CDO="@abs_top_builddir@/src/cdo $CDO_DEBUG"
test -n "$DATAPATH" || DATAPATH="@abs_top_srcdir@/test/data/"
#
FORMAT="-f srv -b 32"
OPERATORS="add sub mul div"
#
NTEST=1
#
for OPERATOR in $OPERATORS; do
    if [ -z "$1" ] || [ $NTEST == "$1" ]; then
        IFILE1=$DATAPATH/arith1.srv
        IFILE2=$DATAPATH/arithmask.srv
        OFILE=arith${OPERATOR}_res
        RFILE=$DATAPATH/arith${OPERATOR}_ref

        CDOTEST="$OPERATOR"
        CDOCOMMAND="$CDO  $FORMAT ${OPERATOR} $IFILE1 $IFILE2 $OFILE"
        TESTCOMMAND="$CDO  diff $OFILE $RFILE"

        runTest
        rm -f "$OFILE"
    fi
    (( NTEST+=1 ))
done
#
for OPERATOR in $OPERATORS; do
    if [ -z "$1" ] || [ $NTEST == "$1" ]; then
        # expr,instr var

        OP=""
        if [ "$OPERATOR" = add ] ; then OP='+' ; fi
        if [ "$OPERATOR" = sub ] ; then OP='-' ; fi
        if [ "$OPERATOR" = mul ] ; then OP='*' ; fi
        if [ "$OPERATOR" = div ] ; then OP='/' ; fi

        RFILE=$DATAPATH/arith${OPERATOR}_ref
        IFILE=$DATAPATH/expr1.srv
        OFILE=expr${OPERATOR}_res

        INSTR="var215=var215${OP}var3;var216=var216${OP}var3;"
        echo $INSTR

        CDOTEST="$OPERATOR"
        CDOCOMMAND="$CDO  $FORMAT expr,$INSTR $IFILE $OFILE"
        TESTCOMMAND="$CDO  diff $OFILE $RFILE"

        runTest
        rm -f "$OFILE"
    fi

    (( NTEST+=1 ))
done
#
for OPERATOR in $OPERATORS; do
    if [ -z "$1" ] || [ $NTEST == "$1" ]; then
        IFILE1=$DATAPATH/arith2.srv
        IFILE2=$DATAPATH/arith2mean.srv
        OFILE=arith2${OPERATOR}_res
        RFILE=$DATAPATH/arith2${OPERATOR}_ref

        CDOTEST="$OPERATOR"
        CDOCOMMAND="$CDO  $FORMAT ${OPERATOR} $IFILE1 $IFILE2 $OFILE"
        TESTCOMMAND="$CDO  diff $OFILE $RFILE"

        runTest
        rm -f "$OFILE"
    fi
    (( NTEST+=1 ))
done
#
exit 0
